## ---------------------------
##
## Script name: Load data for the model
##
## Purpose of script: Master script to load data for the gadget model
##
## ---------------------------

## Source or list custom functions used within the script

## ---------------------------

##########################
## Modify reload_data ####

remake_init_sigmas <- reload_data

if(reset_model | !(exists("optim_fit") | file.exists(file.path(base_dir, "optim/Optimized TMB model fit.rda")))) {
  remake_init_sigmas <- FALSE
}

## Life history parameters

source("2-1 life history.R")

## Survey indices

### Download data
#### Updates the survey indices but requires IMR server connection.
#### Modify server_path to fit your system

if(reload_data) {
  server_path <- "/Volumes/Felles/_Dyphavsarter/Arter/Blakveite/GADGET/Stox/GHL"

  if(!dir.exists(server_path)) {
    message("Cannot connect to IMR servers. Loading data from the data folder
            instead of download from the servers.")

    load("data/EggaN survey index data.rda")
    load("data/EggaS survey index data.rda")
    load("data/Ecosystem survey index data.rda")

  } else {
    source("2-2-1 download survey indices.R")
  }
} else {
  load("data/EggaN survey index data.rda")
  load("data/EggaS survey index data.rda")
  load("data/Ecosystem survey index data.rda")
}

source("2-2-2 survey indices.R")

## Length, sex and maturity distributions

# source("2-3-1 download distribution data.R") # Not written yet. The code is in ghl-gadget-data repo
source("2-3-2 catch distributions.R")

## Catches

# source("2-4-1 download catch data.R") # Not written yet. The code is in ghl-gadget-data repo

source("2-4-2 catches.R")
