## ---------------------------
##
## Script name: Gadget fleets
##
## Purpose of script: Set up fleets
##
## ---------------------------
## Read data

if(!exists("TrawlNor_catches")) source("2-3 landings.R")

# load("data/out/Landings to Gadget.rda")

## Source functions

# source("R/figure_functions.R")

## ---------------------------

## Surveys

EggaN <- g3_fleet(c("EggaN", "survey")) %>%
  g3s_livesonareas(areas[c('1')])

EggaS <- g3_fleet(c("EggaS", "survey")) %>%
  g3s_livesonareas(areas[c('1')])

EcoS <- g3_fleet(c("EcoS", "survey")) %>%
  g3s_livesonareas(areas[c('1')])

WinterS <- g3_fleet(c("WinterS", "survey")) %>%
  g3s_livesonareas(areas[c('1')])

RussianS <- g3_fleet(c("RussianS", "survey")) %>%
  g3s_livesonareas(areas[c('1')])

## Commercial

TrawlNor <- g3_fleet(c("TrawlNor", "fishery")) %>%
  g3s_livesonareas(areas[c('1')])

OtherNor <- g3_fleet(c("OtherNor", "fishery")) %>%
  g3s_livesonareas(areas[c('1')])

TrawlRus <- g3_fleet(c("TrawlRus", "fishery")) %>%
  g3s_livesonareas(areas[c('1')])

OtherRus <- g3_fleet(c("OtherRus", "fishery")) %>%
  g3s_livesonareas(areas[c('1')])

Internat <- g3_fleet(c("Internat", "fishery")) %>%
  g3s_livesonareas(areas[c('1')])

## Create fleet actions

exponentiate_fleets <- FALSE

fleet_actions <-
  list(
    TrawlNor %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species','sex')),
            #   p1 = g3_parameterized('trawlnor.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('trawlnor.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('trawlnor.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('trawlnor.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('trawlnor.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('TrawlNor_catches', TrawlNor_catches)
          )
      ),
    OtherNor %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species', 'sex')),
            #   p1 = g3_parameterized('other.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('other.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('other.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('othernor.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('othernor.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('OtherNor_catches', OtherNor_catches)
          )
      ),
    TrawlRus %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species', 'sex')),
            #   p1 = g3_parameterized('trawlrus.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('trawlrus.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('trawlrus.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('trawlrus.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('trawlrus.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('TrawlRus_catches', TrawlRus_catches)
          )
      ),
    OtherRus %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species', 'sex')),
            #   p1 = g3_parameterized('otherrus.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('otherrus.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('otherrus.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('othernor.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('othernor.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('OtherRus_catches', OtherRus_catches)
          )
      ),
    Internat %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species','sex')),
            #   p1 = g3_parameterized('trawlnor.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('trawlnor.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('trawlnor.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('trawlnor.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('trawlnor.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('Internat_catches', Internat_catches)
          )
      ),
    EggaN %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            g3_suitability_exponentiall50(
              g3_parameterized('eggan.survey.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('eggan.survey.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('EggaN_catches', EggaN_catches)
          )
      ),
    EggaS %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            g3_suitability_exponentiall50(
              g3_parameterized('eggas.survey.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('eggas.survey.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('EggaS_catches', EggaS_catches)
          )
      ),
    EcoS %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species', 'sex')),
            #   p1 = g3_parameterized('ecos.survey.p1', by_stock = c('species', 'sex')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species', 'sex')),
            #   p3 = g3_parameterized('ecos.survey.p3', by_stock = c('species', 'sex')),
            #   p4 = g3_parameterized('ecos.survey.p4', by_stock = c('species', 'sex')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species', 'sex'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('ecos.survey.alpha', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('ecos.survey.l50', by_stock = c('species', 'sex'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('EcoS_catches', EcoS_catches)
          )
          # g3a_predate_catchability_effortfleet(
          #   catchability_fs = ~1,
          #   E = ~1e-8)
      ),
    WinterS %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            # g3_suitability_andersen(
            #   g3_parameterized('andersen.p0', by_stock = c('species')),
            #   p1 = g3_parameterized('winters.survey.p1', by_stock = c('species')),
            #   p2 = g3_parameterized('andersen.p2', by_stock = c('species')),
            #   p3 = g3_parameterized('winters.survey.p3', by_stock = c('species')),
            #   p4 = g3_parameterized('winters.survey.p4', by_stock = c('species')),
            #   p5 = g3_parameterized('andersen.L', by_stock = c('species'))
            # )
            g3_suitability_exponentiall50(
              g3_parameterized('winters.survey.alpha', by_stock = c('species'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('winters.survey.l50', by_stock = c('species'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('WinterS_catches', WinterS_catches)
          )
      ),
    RussianS %>%
      g3a_predate_fleet(
        stocks,
        suitabilities =
          stocks %>%
          set_names(.,map(.,'name')) %>%
          map(function(x)
            g3_suitability_exponentiall50(
              g3_parameterized('russians.survey.alpha', by_stock = c('species'),
                               exponentiate = exponentiate_fleets),
              g3_parameterized('russians.survey.l50', by_stock = c('species'),
                               exponentiate = exponentiate_fleets)
            )
          ),
        catchability_f =
          g3a_predate_catchability_totalfleet(
            g3_timeareadata('RussianS_catches', RussianS_catches)
          )
      )
  )

